"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var paths_exports = {};
__export(paths_exports, {
  resolveActionsModuleId: () => resolveActionsModuleId,
  resolveDependenciesModuleId: () => resolveDependenciesModuleId,
  resolveHandlerModuleId: () => resolveHandlerModuleId
});
module.exports = __toCommonJS(paths_exports);
var import_node_fs = __toESM(require("node:fs"));
var import_node_path = __toESM(require("node:path"));
var import_assert = require("@code-like-a-carpenter/assert");
function resolveActionsModuleId(config, directory) {
  if (config.actionsModuleId.startsWith(".")) {
    const resolved = import_node_path.default.relative(directory, config.actionsModuleId);
    return resolved.replace(new RegExp(`${import_node_path.default.extname(resolved)}$`), "");
  }
  return config.actionsModuleId;
}
function resolveDependenciesModuleId(config, directory) {
  if (config.dependenciesModuleId.startsWith(".")) {
    return import_node_path.default.relative(directory, config.dependenciesModuleId);
  }
  return config.dependenciesModuleId;
}
function resolveHandlerModuleId(type, directory, handler) {
  if (!handler.startsWith(".")) {
    return handler;
  }
  (0, import_assert.assert)(type.astNode, `Expected ${type.name} to have an AST node`);
  (0, import_assert.assert)(
    type.astNode.description,
    `Expected ${type.name} to have a description`
  );
  (0, import_assert.assert)(
    type.astNode.description.loc,
    `Expected ${type.name} to have a location`
  );
  (0, import_assert.assert)(
    type.astNode.description.loc.source,
    `Expected ${type.name} to have a source`
  );
  (0, import_assert.assert)(
    type.astNode.description.loc.source.name,
    `Expected ${type.name} to have a name`
  );
  const schemaFile = type.astNode.description.loc.source.name;
  if (process.env.NODE_ENV !== "test") {
    (0, import_assert.assert)(import_node_fs.default.statSync(schemaFile), `Expected ${schemaFile} to exist`);
  }
  const absolutePathToHandler = import_node_path.default.join(import_node_path.default.dirname(schemaFile), handler);
  const absolutePathToDirectory = import_node_path.default.resolve(directory);
  return import_node_path.default.relative(absolutePathToDirectory, absolutePathToHandler);
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  resolveActionsModuleId,
  resolveDependenciesModuleId,
  resolveHandlerModuleId
});
